package cn.com.ctop.job.bytedance.handler;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.toutiao.modules.material.service.IByteDanceAdvertiserDataService;
import cn.com.ctop.toutiao.modules.report.service.IBytedanceReportService;
import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.jeecg.common.util.DateUtils;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class BytedanceDailyMaterialReportJob {

    static ExecutorService executorService = Executors.newFixedThreadPool(4);
    @Autowired
    private ICtopOauthTokenService tokenService;
    @Autowired
    private IBytedanceReportService bytedanceReportService;

    @XxlJob("bytedanceDailyMaterialReportJob")
    public ReturnT<String> execute(String param) throws Exception {
        Date getDate2 = DateUtils.addDay(new Date(), -2);
        String date2 = DateUtils.formatDate(getDate2);

        Date getDate = DateUtils.addDay(new Date(), -1);
        String date = DateUtils.formatDate(getDate);
        XxlJobLogger.log("头条获取素材报表数据任务开始，任务时间：" + date2 + "~" + date);

        List<CtopOauthToken> tokens = tokenService.selectToutiaoToken();
        if (null == tokens || tokens.size() <= 0) {
            XxlJobLogger.log("头条获取素材报表数据任务执行失败:未获取到可用的token");
            return ReturnT.FAIL;
        }

        tokens.forEach(token -> {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        //获取头条素材报表两天前的数据
                        XxlJobLogger.log("账户"+token.getAccountId() + "素材报表数据任务开始，任务时间：" + date2 + "~" + date2);
                        bytedanceReportService.bytedanceMaterialReport(token, date2, date2);
                        XxlJobLogger.log("账户"+token.getAccountId() + "素材报表数据任务完成，任务时间：" + date2 + "~" + date2);

                        //获取头条素材报表数据
                        XxlJobLogger.log("账户"+token.getAccountId() + "素材报表数据任务开始，任务时间：" + date + "~" + date);
                        bytedanceReportService.bytedanceMaterialReport(token, date, date);
                        XxlJobLogger.log("账户"+token.getAccountId() + "素材报表数据任务完成，任务时间：" + date + "~" + date);
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                    }
                }
            });
        });
        return ReturnT.SUCCESS;
    }



}
